var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @author recompose (https://github.com/acdlite/recompose)
 */

import { Component } from 'inferno';
import { createChangeEmitter } from 'change-emitter';
import $$observable from 'symbol-observable';
import { config as globalConfig } from './setObservableConfig';

export var componentFromStreamWithConfig = function componentFromStreamWithConfig(config) {
	return function (propsToVdom) {
		return function (_Component) {
			_inherits(ComponentFromStream, _Component);

			function ComponentFromStream() {
				var _ref;

				var _temp, _this, _ret;

				_classCallCheck(this, ComponentFromStream);

				for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
					args[_key] = arguments[_key];
				}

				return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ComponentFromStream.__proto__ || Object.getPrototypeOf(ComponentFromStream)).call.apply(_ref, [this].concat(args))), _this), _this.state = { vdom: null }, _this.propsEmitter = createChangeEmitter(), _this.props$ = config.fromESObservable(_defineProperty({
					subscribe: function subscribe(observer) {
						var unsubscribe = _this.propsEmitter.listen(function (props) {
							if (props) {
								observer.next(props);
							} else {
								observer.complete();
							}
						});
						return { unsubscribe: unsubscribe };
					}
				}, $$observable, function () {
					return this;
				})), _this.vdom$ = config.toESObservable(propsToVdom(_this.props$)), _temp), _possibleConstructorReturn(_this, _ret);
			}

			// Stream of props


			// Stream of vdom


			_createClass(ComponentFromStream, [{
				key: 'componentWillMount',
				value: function componentWillMount() {
					var _this2 = this;

					// Subscribe to child prop changes so we know when to re-render
					this.subscription = this.vdom$.subscribe({
						next: function next(vdom) {
							_this2.setState({ vdom: vdom });
						}
					});
					this.propsEmitter.emit(this.props);
				}
			}, {
				key: 'componentWillReceiveProps',
				value: function componentWillReceiveProps(nextProps) {
					// Receive new props from the owner
					this.propsEmitter.emit(nextProps);
				}
			}, {
				key: 'shouldComponentUpdate',
				value: function shouldComponentUpdate(nextProps, nextState) {
					return nextState.vdom !== this.state.vdom;
				}
			}, {
				key: 'componentWillUnmount',
				value: function componentWillUnmount() {
					// Call without arguments to complete stream
					this.propsEmitter.emit();

					// Clean-up subscription before un-mounting
					this.subscription.unsubscribe();
				}
			}, {
				key: 'render',
				value: function render() {
					return this.state.vdom;
				}
			}]);

			return ComponentFromStream;
		}(Component);
	};
};

var componentFromStream = function componentFromStream(propsToVdom) {
	return componentFromStreamWithConfig(globalConfig)(propsToVdom);
};

export default componentFromStream;